;; Packages
(load "~/.emacs.d/packages.el")

;; Convenient functions
(load "~/.emacs.d/functions.el")

;; Tab width
(setq-default tab-width 4)

;; Remove useless stuff
(menu-bar-mode 0)
(tool-bar-mode 0)
(scroll-bar-mode 0)

;; UTF-8!!!!
(set-language-environment "UTF-8")

;; Appearance
(set-frame-font "DejaVu Sans Mono 10")
(set-face-italic 'font-lock-comment-face nil)  ; disable italics
; theme set in packages.el
(global-linum-mode)
(blink-cursor-mode nil)
(when window-system (global-hl-line-mode t))
(show-paren-mode t)

;; Mode line
(line-number-mode t)
(column-number-mode t)
(setq display-time-24hr-format t)
(display-time-mode t)

;; disable creation of backup files
(setq make-backup-files nil)
(setq auto-save-default nil)

;; Y or N instead of Yes or No
(defalias 'yes-or-no-p 'y-or-n-p)

;; Smaller skips when cursor reaches end of screen
(setq scroll-conservatively 100)

;; Disable bell
(setq ring-bell-function 'ignore)

;; Subword for camelCase words
(global-subword-mode t)

;; Electric pair mode
(setq electric-pair-pairs '((?\( . ?\))
							(?\[ . ?\])
							(?\{ . ?\})
							(?\" . ?\")
							))
(electric-pair-mode t)

;; windmove
(global-set-key (kbd "C-:")  'windmove-left)
(global-set-key (kbd "C-|")  'windmove-right)
(global-set-key (kbd "C-{")  'windmove-up)
(global-set-key (kbd "C-\"") 'windmove-down)

;; Terminal
(defvar term-shell "/bin/zsh")
(defadvice ansi-term (before force-bash)
  (interactive (list term-shell)))
(ad-activate 'ansi-term)

;; C configuration
(setq c-default-style "linux"
      c-basic-offset 4)

;; Disable bold fonts
(mapc
 (lambda (face)
   (set-face-attribute face nil :weight 'normal))
 (face-list))

;; Eshell
(defalias 'open 'find-file-other-window)
(defalias 'clean 'eshell/clear-scrollback)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(custom-set-variables
 ;; custom-set-variables was added by Custom.
 ;; If you edit it by hand, you could mess it up, so be careful.
 ;; Your init file should contain only one such instance.
 ;; If there is more than one, they won't work right.
 '(package-selected-packages
   '(avy swiper auto-package-update magit expand-region go-mode tao-themes tao-theme almost-mono-themes use-package)))
(custom-set-faces
 ;; custom-set-faces was added by Custom.
 ;; If you edit it by hand, you could mess it up, so be careful.
 ;; Your init file should contain only one such instance.
 ;; If there is more than one, they won't work right.
 )
;; 
(put 'downcase-region 'disabled nil)
